package com.agiledeveloper;

import junit.framework.TestCase;
import static org.easymock.EasyMock.*;

public class TestScoreStore extends TestCase
{
    private static final String PLAYER_NAME = "VENKAT";

    public void testSetScore()
    {
        IRepository repository = (IRepository) createMock(IRepository.class);

        ScoreStore store = new ScoreStore(repository);
        expect(repository.getPlayCount(PLAYER_NAME)).andReturn(0);
        expect(repository.getBestScore(PLAYER_NAME)).andReturn(Integer.MAX_VALUE);
        expect(repository.getWorstScore(PLAYER_NAME)).andReturn(0);
        repository.set(PLAYER_NAME, 1, 6, 6);
        expect(repository.getPlayCount(PLAYER_NAME)).andReturn(1);
        expect(repository.getBestScore(PLAYER_NAME)).andReturn(6);
        expect(repository.getWorstScore(PLAYER_NAME)).andReturn(6);

        replay(repository);
        store.update(PLAYER_NAME, 6);

        assertEquals(1, store.getPlayCount(PLAYER_NAME));
        assertEquals(6, store.getBestScore(PLAYER_NAME));
        assertEquals(6, store.getWorstScore(PLAYER_NAME));
        verify(repository);
    }
}
